#define WIDTH 200
#define HEIGHT 400
#include "cairo-tutorial.h"

static void
fill_background (cairo_t *cr)
{
    int i, j;

    for (i=0; i < WIDTH/10; i++)
	for (j=0; j < HEIGHT/10; j++) {
	    cairo_rectangle (cr, 10*i, 10*j, 10*(i+1), 10*(j+1));
	    if ((i+j) % 2 == 0)
		cairo_set_source_rgb (cr, 0.75, .75, .75);
	    else
		cairo_set_source_rgb (cr, 0.25, .25, .25);
	    cairo_fill (cr);
	}
}

static void
line (cairo_t *cr, double offset)
{
    cairo_move_to (cr, offset + 50, 50);
    cairo_line_to (cr, offset + 50, 350);
}

static void
draw (cairo_t *cr)
{
    fill_background (cr);
    cairo_set_line_width (cr, 40);

    line (cr, 0);
    cairo_set_line_cap (cr, CAIRO_LINE_CAP_SQUARE);
    cairo_set_source_rgba (cr, 1.0, 0.0, 0.0, 0.6);
    cairo_stroke (cr);

    line (cr, 50);
    cairo_set_line_cap (cr, CAIRO_LINE_CAP_ROUND);
    cairo_set_source_rgba (cr, 0.0, 1.0, 0.0, 0.6);
    cairo_stroke (cr);

    line (cr, 100);
    cairo_set_line_cap (cr, CAIRO_LINE_CAP_BUTT);
    cairo_set_source_rgba (cr, 0.0, 0.0, 1.0, 0.6);
    cairo_stroke (cr);
}
